<template>
  <div class="app-container">
    <div class="search">
      <el-input v-model="table.getdataListParm.parammaps.bname" placeholder="栏舍名称" style="width: 180px;" class="filter-item" clearable />
      <el-input v-model="table.getdataListParm.parammaps.bcode" placeholder="栏舍编号" style="width: 180px;" class="filter-item" clearable />
      <el-select v-model="table.getdataListParm.parammaps.enable" filterable placeholder="是否启用" class="filter-item" style="width: 120px;" clearable>
        <el-option v-for="item in enableList" :key="item.id" :label="item.name" :value="item.id" />
      </el-select>
      <div ref="selectInput" class="filter-item selectInput">
        <el-input type="text" name="" value="" placeholder="请点击选择搜索条件" class="Input" />
        <i v-if="arrowDown" icon="el-icon-arrow-down" class="el-icon-arrow-down" />
        <i v-if="arrowUp" icon="el-icon-arrow-up" class="el-icon-arrow-up" />
        <ul v-if="arrowUp" class="selectUl">
          <li><a>允许误差数</a><el-input v-model="table.getdataListParm.parammaps.allowratio" type="text" style="width: 245px;" /></li>
          <li><a>跳转重量域</a><el-input v-model="table.getdataListParm.parammaps.autozone" type="text" style="width: 245px;" /></li>
          <li>
            <a>跳转延时</a>
            <el-select v-model="table.getdataListParm.parammaps.autosecond" filterable class="filter-item" style="width: 245px;" clearable>
              <el-option v-for="item in jumpDelayList" :key="item.value" :label="item.label" :value="item.value" />
            </el-select>
          </li>
          <li>
            <div style="float: right;">
              <el-button class="downminCancel" @click="arrowUp=false;arrowDown=true;">取消</el-button>
              <el-button class="miniPrimary" @click="handleSearch">搜索</el-button>
            </div>
          </li>
        </ul>
      </div>
      <el-button class="successBorder" @click="handleSearch">查询</el-button>
      <el-button class="successBorder" @click="handleRefresh">重置</el-button>
    </div>
    <div class="operation">
      <el-button v-if="isRoleEdit" style="float:left;" class="success" icon="el-icon-plus" @click="handleCreate">新增</el-button>
      <el-button v-if="isRoleEdit" style="float:left;" class="danger" icon="el-icon-delete" @click="handleDelete">删除</el-button>
      <el-button v-if="isOrder && isRoleEdit" style="float:left;" icon="el-icon-sort" class="success" @click="handleChangeOrder">更改顺序</el-button>
       <div v-else style="float:left;margin-left: 10px;">
        <el-button v-if="isRoleEdit" icon="el-icon-folder-checked" class="success" @click="saveChangeOrder">保存</el-button>
        <el-button v-if="isRoleEdit" icon="el-icon-close" class="sortCancel" @click="cancelChangeOrder">取消</el-button>
      </div>
    </div>
    <div class="table">
      <u-table
        id="table"
        :key="table.tableKey"
        ref="table"
        v-loading="table.listLoading"
        element-loading-text="给我一点时间"
        :data="table.list"
        border
        fit
        highlight-current-row
        style="width: 100%;"
        :row-style="rowStyle"
        :cell-style="cellStyle"
        class="elTable table-fixed"
        row-key="id"
        @selection-change="handleSelectionChange"
        :max-height="myHeight"
      >
        <el-table-column type="selection" align="center" width="50" />
        <el-table-column label="序号" type="index" align="center" width="50" />
        <el-table-column label="栏舍名称" min-width="130px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.bname }}</span>
            <el-input v-if="scope.row.Edit" v-model="scope.row.bname" type="textarea" :autosize="{ minRows: 1.3, maxRows: 4}" style="width:95%;padding:10px 0;" maxlength="32" />
          </template>
        </el-table-column>
        <el-table-column label="栏舍编号" min-width="130px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.bcode }}</span>
            <el-input v-if="scope.row.Edit" v-model="scope.row.bcode" placeholder="1-32个字符" type="textarea" :autosize="{ minRows: 1.3, maxRows: 4}" maxlength="32" style="width:95%;padding:10px 0;" />
          </template>
        </el-table-column>
        <el-table-column label="允许误差数（kg）" min-width="150px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.allowratio }}</span>
            <el-input v-if="scope.row.Edit" v-model="scope.row.allowratio" style="width:95%;padding:10px 0;" />
          </template>
        </el-table-column>
        <el-table-column label="跳转重量域（kg）" min-width="150px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.autozone }}</span>
            <el-input v-if="scope.row.Edit" v-model="scope.row.autozone" :disabled="scope.row.autosecond=='0'" style="width:95%;padding:10px 0;" />
          </template>
        </el-table-column>
        <el-table-column label="跳转延时（s）" min-width="150px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.autosecondname }}</span>
            <el-select v-if="scope.row.Edit" v-model="scope.row.autosecond" filterable class="filter-item" style="width: 95%;padding:10px 0;" @change="changeAutosecond">
              <el-option v-for="item in jumpDelayList" :key="item.value" :label="item.label" :value="item.value" />
              <!-- <el-option v-for="item in jumpDelayList" :key="item.label" :label="item.label" :value="item.label" /> -->
            </el-select>
          </template>
        </el-table-column>
        <el-table-column label="确认开始" min-width="110px" align="center">
          <template slot-scope="scope">
            <el-switch v-model="scope.row.isstart" :disabled="scope.row.NoEdit==true" active-color="#13ce66" inactive-color="#ff4949" :active-value="1" :inactive-value="0" @change="handleConfirmStartChange(scope.$index, scope.row)" />
          </template>
        </el-table-column>
        <el-table-column label="是否启用" min-width="110px" align="center">
          <template slot-scope="scope">
            <el-switch v-model="scope.row.enable" :disabled="scope.row.NoEdit==true" active-color="#13ce66" inactive-color="#ff4949" :active-value="1" :inactive-value="0" @change="handleEnableChange(scope.$index, scope.row)" />
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="80" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="{row}">
            <!-- 新增 -->
            <el-button v-if="row.isCreate" :disabled="isokDisable" icon="el-icon-folder-checked" class="miniSuccess" @click="createData(row)" />
            <span v-if="row.isCreate" class="centerSpan">|</span>
            <el-button v-if="row.isCreate" class="minCancel" icon="el-icon-close" @click="createCancel(row)" />
            <!-- 编辑 -->
            <el-button v-if="row.isUpdate && isRoleEdit" class="miniSuccess" icon="el-icon-edit-outline" @click="handleUpdate(row)" />
            <span v-if="row.isUpdate && isRoleEdit" class="centerSpan">|</span>
            <el-button v-if="row.isUpdate && isRoleEdit" class="miniDanger" icon="el-icon-delete" @click="handleRowDelete(row)" />
            <!-- 编辑保存 -->
            <el-button v-if="row.isUpdateSave" :disabled="isokDisable" icon="el-icon-folder-checked" class="miniSuccess" @click="updateData(row)" />
            <span v-if="row.isUpdateSave" class="centerSpan">|</span>
            <el-button v-if="row.isUpdateSave" class="minCancel" icon="el-icon-close" @click="updateCancel(row)" />
          </template>
        </el-table-column>
      </u-table>
      <span v-if="table.listLoading == false" style="margin-right: 30px;margin-top: 10px;font-size: 14px;">共{{ table.total }}条</span>
      <!-- <pagination v-show="table.total>=0" :total="table.total" :page.sync="table.getdataListParm.offset" :limit.sync="table.getdataListParm.pagecount" @pagination="getList" /> -->
    </div>
  </div>

</template>

<script>
import { GetDataByName, GetDataByNames, PostDataByName, failproccess, ExecDataByConfig, checkButtons } from '@/api/common'
import Cookies from 'js-cookie'
import draggable from 'vuedraggable'
import Sortable from 'sortablejs'
import Pagination from '@/components/Pagination'
import { MessageBox } from 'element-ui'
export default {
  name: 'GroupColumn',
  components: { Pagination,draggable },
  data() {
    return {
      isRoleEdit: [],
      requestParams: [
        { name: 'getDictByName', offset: 0, pagecount: 0, params: ['跳转延时'] }
      ],
      enableList: [{ id: '1', name: '是' }, { id: '0', name: '否' }],
      jumpDelayList: [],

      table: {
        getdataListParm: {
          name: 'getBarList',
          page: 1,
          offset: 1,
          pagecount: '',
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            bcode: '',
            bname: '',
            allowratio: '',
            autozone: '',
            autosecond: '',
            enable: ''
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true,
        temp: {}
      },
      requestParam: {},
      isokDisable: false,
      selectList: [],
      arrowDown: true,
      arrowUp: false,
      rowStyle: { maxHeight: 30 + 'px', height: 30 + 'px' },
      cellStyle: { padding: 0 + 'px' },
      dropState: false,
      isOrder: true,
      myHeight:document.documentElement.clientHeight - 85- 150
    }
  },

  created() {
    this.getList()
    this.getDownList()
    this.getButtons()
  },
  mounted() {
    document.addEventListener('click', (e) => {
      if (this.$refs.selectInput !== undefined) {
        if (!this.$refs.selectInput.contains(e.target)) {
          this.arrowDown = true
          this.arrowUp = false
        } else {
          this.arrowDown = false
          this.arrowUp = true
        }
      }
    })
  },
  methods: {
    getButtons() {
      const Edit = 'GroupColumn'
      const isRoleEdit = checkButtons(JSON.parse(sessionStorage.getItem('buttons')), Edit)
      this.isRoleEdit = isRoleEdit
    },
    getDownList() {
      GetDataByNames(this.requestParams).then(response => {
        this.jumpDelayList = response.data.getDictByName.list
      })
    },
    getList() {
      this.table.listLoading = true
      GetDataByName(this.table.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            this.$set(response.data.list[i], 'Edit', false) // 编辑
            this.$set(response.data.list[i], 'NoEdit', true) // 不可编辑/输入
            this.$set(response.data.list[i], 'isCreate', false) // 新增操作
            this.$set(response.data.list[i], 'isUpdate', true) // 编辑操作
            this.$set(response.data.list[i], 'isUpdateSave', false) // 编辑保存
          }
          this.table.list = response.data.list
          this.table.pageNum = response.data.pageNum
          this.table.pageSize = response.data.pageSize
        } else {
          this.table.list = []
        }
        this.table.total = response.data.total
        setTimeout(() => {
          this.table.listLoading = false
        }, 100)
      })
    },
    handleEnableChange() {
      console.log('点击了是否启用')
    },
    handleConfirmStartChange() {
      console.log('点击了确认开始')
    },
    handleSearch() {
      console.log('点击了查询')
      this.table.getdataListParm.offset = 1
      this.getList()
      this.arrowDown = true
      this.arrowUp = false
    },
    handleRefresh() {
      console.log('点击了重置')
      this.table.getdataListParm.parammaps.bcode = ''
      this.table.getdataListParm.parammaps.bname = ''
      this.table.getdataListParm.parammaps.allowratio = ''
      this.table.getdataListParm.parammaps.autozone = ''
      this.table.getdataListParm.parammaps.autosecond = ''
      this.table.getdataListParm.parammaps.enable = ''
      this.table.getdataListParm.offset = 1
      this.getList()
    },

    changeAutosecond(item) {
      this.table.temp.autosecondname = this.jumpDelayList.find(obj => obj.value === item).label
      console.log(this.table.temp.autosecondname)
    },
    handleCreate() {
      console.log('点击了新增')
      // 编辑true/不可编辑false
      // 新增操true,编辑false，编辑保存false
      for (let i = 0; i < this.table.list.length; i++) {
        if (this.table.list[i].Edit == true) {
          this.$message({ type: 'error', message: '当前内容未保存，请点击取消或保存继续进行操作', duration: 2000 })
          return false
        }
      }
      this.table.temp.autosecondname = ''
      this.table.list.unshift({ 'myId': (new Date()).valueOf(), 'Edit': true, 'NoEdit': false, 'isCreate': true, 'isUpdate': false, 'isUpdateSave': false, 'enable': 1, 'isstart': 1, 'bname': '', 'bcode': '', 'allowratio': '', 'autozone': '', 'autosecond': '0', 'autosecondname': '禁用' })
    },
    createData(row) {
      console.log('点击了新增保存', row)
      this.table.temp.pastureid = Cookies.get('pastureid')
      this.table.temp.bcode = row.bcode
      this.table.temp.bname = row.bname
      this.table.temp.allowratio = row.allowratio
      this.table.temp.autozone = row.autozone
      this.table.temp.autosecond = row.autosecond
      if (this.table.temp.autosecondname == '') {
        this.table.temp.autosecondname = row.autosecondname
      } else {
        this.table.temp.autosecondname = this.table.temp.autosecondname
      }

      this.table.temp.isstart = row.isstart
      this.table.temp.enable = row.enable
      // 检验用户名称/角色是否为空
      if (this.table.temp.bname == '' && this.table.temp.bcode == '') {
        this.$message({ type: 'error', message: '栏舍名称/栏舍编号不能为空', duration: 2000 })
        return false
      } else if (this.table.temp.bname == '') {
        this.$message({ type: 'error', message: '栏舍名称不能为空', duration: 2000 })
        return false
      } else if (this.table.temp.bcode == '') {
        this.$message({ type: 'error', message: '栏舍编号不能为空', duration: 2000 })
        return false
      }

      // if (this.table.temp.bcode.length > 8) {
      //   this.$message({ type: 'error', message: '栏舍编号请输入1-8位数字', duration: 2000 })
      //   return false
      // }
      if (this.table.temp.allowratio !== '') {
        console.log(this.table.temp.allowratio)
        const allowratio = /^[0-9]\d*$/
        if (!allowratio.test(parseFloat(this.table.temp.allowratio))) {
          this.$message({ type: 'error', message: '允许误差数请输入大于等于0的整数', duration: 2000 })
          return false
        }
      } else {
        this.table.temp.allowratio = '0'
      }
      if (this.table.temp.autozone !== '') {
        console.log(this.table.temp.autozone)
        const autozone = /^(\d|[1-9]\d|1[0-1]\d|120)$/
        if (!autozone.test(parseFloat(this.table.temp.autozone))) {
          this.$message({ type: 'error', message: '跳转重量域请输入大于等于0小于等于120的整数', duration: 2000 })
          return false
        }
      } else {
        this.table.temp.autozone = '0'
      }
      const pattern = new RegExp("[`~!@#$^&*()=|{}':;',\\[\\].<>/?~！@#￥……&*（）——|{}【】‘；：”“'。，、？]")
      if (pattern.test(this.table.temp.eqcode)) {
        this.$message({ type: 'error', message: 'TMR设备编号不可输入特殊字符', duration: 2000 })
        return false
      }
      if (pattern.test(this.table.temp.tname)) {
        this.$message({ type: 'error', message: 'TMR设备名称不可输入特殊字符', duration: 2000 })
        return false
      }
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.requestParam.name = 'insertBar'
      this.requestParam.parammaps = this.table.temp
      PostDataByName(this.requestParam).then(response => {
        console.log('新增保存发送参数', this.requestParam)
        if (response.msg !== 'fail') {
          this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
          this.getList()
        } else {
          const isRepeat = new RegExp('Duplicate entry :bar_bcode')
          if (isRepeat.test(response.data)) {
            this.$notify({ type: 'error', message: '栏舍编号不可重复，请重新录入', duration: 2000 })
            return false
          }
          this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
        }
      })
    },
    createCancel(row) {
      console.log('点击了新增取消')
      for (let i = 0; i < this.table.list.length; i++) {
        if (row.myId === this.table.list[i].myId) {
          var listIndex = this.table.list.indexOf(this.table.list[i])
        }
        if (listIndex > -1) {
          this.table.list.splice(listIndex, 1)
          return
        }
      }
    },
    handleUpdate(row) {
      console.log('点击了编辑', row)
      for (let i = 0; i < this.table.list.length; i++) {
        if (this.table.list[i].Edit == true) {
          this.$message({ type: 'error', message: '当前内容未保存，请点击取消或保存继续进行操作', duration: 2000 })
          return false
        }
      }
      // 编辑true,不可编辑false
      row.Edit = true
      row.NoEdit = false
      // 新增false,编辑false,编辑保存true
      row.isCreate = false
      row.isUpdate = false
      row.isUpdateSave = true
      row.autosecond = String(row.autosecond)
      this.table.temp.autosecondname = row.autosecondname
      this.table.temp.autosecond = row.autosecond
    },
    updateData(row) {
      console.log('点击了编辑保存', row)
      this.table.temp.pastureid = Cookies.get('pastureid')
      this.table.temp.bcode = row.bcode
      this.table.temp.bname = row.bname
      this.table.temp.allowratio = row.allowratio
      this.table.temp.autozone = row.autozone
      this.table.temp.autosecond = row.autosecond
      this.table.temp.autosecondname = this.table.temp.autosecondname
      this.table.temp.isstart = row.isstart
      this.table.temp.enable = row.enable
      this.table.temp.id = row.id
      // 检验用户名称/角色是否为空
      if (this.table.temp.bname == '' && this.table.temp.bcode == '') {
        this.$message({ type: 'error', message: '栏舍名称/栏舍编号不能为空', duration: 2000 })
        return false
      } else if (this.table.temp.bname == '') {
        this.$message({ type: 'error', message: '栏舍名称不能为空', duration: 2000 })
        return false
      } else if (this.table.temp.bcode == '') {
        this.$message({ type: 'error', message: '栏舍编号不能为空', duration: 2000 })
        return false
      }
      // if (this.table.temp.bcode.length > 8) {
      //   this.$message({ type: 'error', message: '栏舍编号请输入1-8位数字', duration: 2000 })
      //   return false
      // }
      if (this.table.temp.allowratio !== '') {
        console.log(this.table.temp.allowratio)
        const allowratio = /^[0-9]\d*$/
        if (!allowratio.test(parseFloat(this.table.temp.allowratio))) {
          this.$message({ type: 'error', message: '允许误差数请输入大于等于0的整数', duration: 2000 })
          return false
        }
      } else {
        this.table.temp.allowratio = '0'
      }
      if (this.table.temp.autozone !== '') {
        console.log(this.table.temp.autozone)
        const autozone = /^(\d|[1-9]\d|1[0-1]\d|120)$/
        if (!autozone.test(parseFloat(this.table.temp.autozone))) {
          this.$message({ type: 'error', message: '跳转重量域请输入大于等于0小于等于120的整数', duration: 2000 })
          return false
        }
      } else {
        this.table.temp.autozone = '0'
      }
      const pattern = new RegExp("[`~!@#$^&*()=|{}':;',\\[\\].<>/?~！@#￥……&*（）——|{}【】‘；：”“'。，、？]")
      if (pattern.test(this.table.temp.eqcode)) {
        this.$message({ type: 'error', message: 'TMR设备编号不可输入特殊字符', duration: 2000 })
        return false
      }
      if (pattern.test(this.table.temp.tname)) {
        this.$message({ type: 'error', message: 'TMR设备名称不可输入特殊字符', duration: 2000 })
        return false
      }
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.requestParam.name = 'updateBar'
      this.requestParam.parammaps = this.table.temp
      PostDataByName(this.requestParam).then(response => {
        console.log('新增保存发送参数', this.requestParam)
        if (response.msg !== 'fail') {
          this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
          this.getList()
        } else {
          const isRepeat = new RegExp('Duplicate entry :bar_bcode')
          if (isRepeat.test(response.data)) {
            this.$notify({ type: 'error', message: '栏舍编号不可重复，请重新录入', duration: 2000 })
            return false
          }
          this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
        }
      })
    },
    updateCancel(row) {
      console.log('点击了编辑取消')
      // 编辑false,不可编辑true
      row.Edit = false
      row.NoEdit = true
      // 新增false,编辑true,编辑保存false
      row.isCreate = false
      row.isUpdate = true
      row.isUpdateSave = false
      this.getList()
    },
    handleRowDelete(row) {
      console.log('点击了行内删除')
      MessageBox.confirm('是否确认删除此信息?', {
        confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
      }).then(() => {
        this.selectList = []
        this.requestParam = {}
        this.requestParam.common = { 'returnmap': '0' }
        this.requestParam.data = []
        this.requestParam.data[0] = { 'name': 'checkDeleteBar', 'type': 'v', 'parammaps': {
          'pastureid': row.pastureid,
          'id': row.id
        }}
        this.requestParam.data[1] = { 'name': 'deleteBar', 'type': 'e', 'parammaps': {
          'pastureid': row.pastureid,
          'id': row.id
        }}
        ExecDataByConfig(this.requestParam).then(response => {
          console.log('删除保存发送参数', this.requestParam)
          if (response.msg === 'fail') {
            this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
          } else {
            this.$notify({ title: '', message: '删除成功', type: 'success', duration: 2000 })
            this.getList()
          }
        })
      }).catch(() => {
        this.$message({ type: 'info', message: '已取消删除' })
      })
    },
    handleSelectionChange(val) {
      console.log('勾选数据', val)
      this.selectList = val
    },
    handleDelete() {
      console.log('点击了删除')
      if (this.selectList.length == 0) {
        this.$message({ type: 'error', message: '请选择舍组栏信息', duration: 2000 })
      } else {
        MessageBox.confirm('当前选中' + this.selectList.length + '条信息，是否删除?', {
          confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
        }).then(() => {
          console.log(this.selectList)
          this.requestParam = {}
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.selectList }}
          this.requestParam.data[0].children = []
          this.requestParam.data[0].children[0] = { 'name': 'checkDeleteBar', 'type': 'v', 'parammaps': {
            id: '@insertSpotList.id',
            pastureid: '@insertSpotList.pastureid'
          }}
          this.requestParam.data[0].children[1] = { 'name': 'deleteBar', 'type': 'e', 'parammaps': {
            id: '@insertSpotList.id',
            pastureid: '@insertSpotList.pastureid'
          }}
          ExecDataByConfig(this.requestParam).then(response => {
            console.log('删除保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '', message: '删除成功', type: 'success', duration: 2000 })
              this.getList()
            }
          })
        })
      }
    },
    handleChangeOrder() {
      this.isOrder = false
      this.rowDrop()
    },

    saveChangeOrder() {
      // 保存顺序
      var sortArr = []
      for (let i = 0; i < this.table.list.length; i++) {
        var obj = {}
        obj.sort = i + 1
        obj.id = this.table.list[i].id
        obj.pastureid = this.table.list[i].pastureid
        sortArr.push(obj)
      }
      this.requestParam = {}
      this.requestParam.common = { 'returnmap': '0' }
      this.requestParam.data = []
      this.requestParam.data[0] = { 'name': 'insertSpotList', 'resultmaps': { 'list': sortArr }}
      this.requestParam.data[0].children = []
      this.requestParam.data[0].children[0] = { 'name': 'updateBarSort', 'type': 'e', 'parammaps': {
        id: '@insertSpotList.id',
        pastureid: '@insertSpotList.pastureid',
        sort: '@insertSpotList.sort'
      }}
      this.table.listLoading = true
      ExecDataByConfig(this.requestParam).then(response => {
        console.log('顺序切换保存发送参数', this.requestParam)
        this.table.listLoading = false
        if (response.msg === 'fail') {
          this.$notify({ title: '顺序切换失败', message: response.data, type: 'warning', duration: 2000 })
        } else {
          this.$notify({ title: '', message: '顺序切换成功', type: 'success', duration: 2000 })
          this.getList()
          this.isOrder = true
        }
      })
    },
    cancelChangeOrder() {
      // 取消顺序
      this.getList()
      this.isOrder = true
    },

     // 行拖拽
    rowDrop() {
      console.log(document.querySelector('#table .el-table__body-wrapper tbody'))
      const tbody = document.querySelector('#table .el-table__body-wrapper tbody')
      const that = this
      var sortable = Sortable.create(tbody, {
        disabled: that.dropState,
        onChoose({ newIndex, oldIndex }) {
          console.log(that.isOrder, 'that.isOrder == false')
          console.log(that.dropState, 'that.dropState')
          if (that.dropState == true || that.isOrder == true) {
            sortable.destroy()
          }
        },
        onEnd({ newIndex, oldIndex }) {
          const currRow = that.table.list.splice(oldIndex, 1)[0]
          that.table.list.splice(newIndex, 0, currRow)
          console.log('currRow', currRow)
          console.log('oldIndex', oldIndex)
          console.log('索引newIndex', newIndex)
          console.log('拖动数据', currRow)
          console.log('上', that.table.list[newIndex - 1])
          console.log('下', that.table.list[newIndex + 1])
        }
      })
    },
  }
}
</script>
<style lang="scss" scoped>
  .search{margin-top:10px;}
  
  $width:350px;
  $left:325px;
  .selectInput{
    position: relative;
    display: inline-block;
    .Input{width: $width;position: relative;}
    .el-icon-arrow-down{width: 30px;height: 30px;position: absolute;left: $left;top:10px;color:#C0C4CC;}
    .el-icon-arrow-up{width: 30px;height: 30px;position: absolute;left: $left;top:10px;color:#C0C4CC;}
    .selectUl{
      z-index: 111;width: $width;background: #fff;border: 1px solid #E4E7ED;box-shadow: 0 2px 12px 0 rgba(0,0,0,.1);margin: -1px 0 0 0;padding: 6px 0; margin: 0;box-sizing: border-box;position: absolute;
      li{
        list-style: none;font-size: 14px; padding: 0 10px; white-space: nowrap; overflow: hidden; text-overflow: ellipsis; color: #606266; height: 50px; line-height: 50px; box-sizing: border-box; cursor: pointer;
        a{float:left;width: 80px;}
        a:hover{color: rgba(0, 204, 102, 0.71); font-weight: 700;}
      }
    }
  }

 </style>
